<?php

if (!defined('_FULLTRACE_CLASS')) {
	define('_FULLTRACE_CLASS', true);

	include('/usr/fallback/beroConf.php');
	include_once ('/usr/local/php/include/restore.Class.php');
	include('/usr/local/www/berogui/includes/isgwtelnet.php');
	include_once('/usr/local/www/berogui/includes/Helper/Helper.php');

	class fulltrace {

		private $_ba;
		private $_bc;
		private $_isgw;

		function __construct () {
			$this->_ba = new beroAri();
			$this->_bc = new beroConf('root');
			$this->_isgw = new isgwtelnet();
			$this->_isgw->isgw_login();
		}

		public static function getDate($formatString = null) {
			@exec('/bin/date ' . (($formatString != null) ? $formatString : '-R'), $output);
			return(trim($output[0]));
		}
		
		// get SIP UDP-Port
		private function _sip_udp_lan () {
			return $this->_ba->get('sip_bindport_lan');
		}
		private function _sip_udp_wan () {
			return $this->_ba->get('sip_bindport_wan');
		}
		private function _sip_udp_vpn () {
			return $this->_ba->get('sip_bindport_vpn');
		}

		// get RTP UDP-Ports
		private function _rtp_udp_lan() {
			$value = $this->_ba->get('rtpports_lan');
			return empty($value) ? false : explode(',', $value);
		}
		private function _rtp_udp_wan() {
			$value = $this->_ba->get('rtpports_wan');
			return empty($value) ? false : explode(',', $value);
		}
		private function _rtp_udp_vpn() {
			$value = $this->_ba->get('rtpports_vpn');
                        return empty($value) ? false : explode(',', $value);
		}


		// get Syslog UDP-Ports
		private function _syslog_udp () {
			$res = $this->_ba->get('logserver');
			$ret = explode(':', $res);
			return($ret[1]);
		}

		// generic data-to-logfile-function
		private function _log ($log_name, $content, $mode) {
			if (($fp = fopen('/var/log/' . $log_name, $mode)) == null) {
				return(false);
			}
			fwrite($fp, $content);
			fclose($fp);

			return(true);
		}

		// write data to log-file
		private function _log_write ($log_name, $content) {
			return($this->_log($log_name, $content, 'w'));
		}

		// append data to log-file
		private function _log_append ($log_name, $content) {
			return($this->_log($log_name, $content, 'w+'));
		}

		// get runtime files
		function get_runtime_files () {

			if ($this->_ba->get('trace') != 'yes') {
				return(null);
			}

			return(array_merge(glob('/var/log/ISDNdebug*'), glob('/var/log/isgw.log*'), glob('/var/log/isgw.nlog*'), glob('/var/log/tcpdump*')));
		}

		// start a fulltrace
		function start ($enable, $isdn_ports, $limit=null, $optlimit=null) {

			$this->_ba->set('trace', 'yes');

			// get name of interface
			if ($this->_bc->get('root','lan-mode') == 'bonding') {
				$lanIfName = 'eth0';
				$wanIfName = '';
			}
			else if ($this->_bc->get('root','lan-ports') == '2') {
				$lanIfName = 'eth0.10' ;
				$wanIfName = 'eth0.11' ;

			}
			else {
				$wanIfName = '';
				$lanIfName = 'eth0' . (($this->_bc->get('root', 'vlan-enable') == 'yes') ? '.' . $this->_bc->get('root', 'vlan-id') : '');
			}
			$locIfName = 'lo';
			$mspIfName = 'eth1';

			if ($limit != null) {
				$limit_mISDN		= (count($isdn_ports) ? $limit * 0.2 * 1000 / count($isdn_ports) : 0);
				$limitTcpDumpLan	= $limit * 0.3;
				$limitTcpDumpWan	= $limit * 0.3;
				$limitTcpDumpLoc	= $limit * 0.2;
				$limitTcpDumpMsp	= $limit * 0.2;
			}
			else {
				$limit_mISDN		= 5000;
				//since we log rotate, size can be twice as big
				if (strlen ($wanIfName)) {
					$limitTcpDumpLan = 2;
					$limitTcpDumpWan = 2;
				}
				else {
					$limitTcpDumpLan = 3;
					$limitTcpDumpWan = 0;
				}
				
				$limitTcpDumpLoc = 1;
				$limitTcpDumpMsp = 0;
			}

			$this->_log_write('fulltrace-starttime.txt', fulltrace::getDate("+%Y-%m-%d\ %H:%M:%S"));

			unset($ports);
			if ($isdn_ports) {
				foreach ($isdn_ports as $isdn_port) {
					$ports .= ((strlen($ports) == 0) ? '' : ',') . $isdn_port;
				}
			}

            if (1) {
				// clear /var/log/
				$logfiles = array('fulltrace-info.txt', 'ISDNdebug-*', 'tcpdump*', 'analog_debug', 'DebugFiles.tar.gz');
				foreach ($logfiles as $logfile) {
					system('/bin/rm -rf /var/log/' . $logfile);
				}
				unset($logfiles);

				// raise ISGW-LogLevel to max
				$this->_isgw->logactive(1);
				$this->_isgw->loglevel(8);
				$this->_isgw->logactive_message(1);
				$this->_isgw->loglevel_message(2);
				$this->_isgw->logactive_nmessage(1);
				$this->_isgw->netlog(1);
				$this->_isgw->lla();
				$this->_isgw->Query('nlog0::Fulltrace started');

				// retrieve data from ISGW
				$isgw_ret = $this->_isgw->isgw_isdnstate();
				$isgw_ret .= $this->_isgw->isgw_actualcalls();
				$isgw_ret .= $this->_isgw->isgw_bchannels();
				$isgw_ret .= $this->_isgw->isgw_callcompact();
				$isgw_ret .= $this->_isgw->isgw_rtpstate();
				$isgw_ret .= $this->_isgw->isgw_listallcallshidden();
				// append ISGW-data to file
				$this->_log_append('isgw.info2', $isgw_ret);
				unset($isgw_ret);


					
				// trace of ISDN-Ports
				$qu = $this->_ba->select('SELECT * FROM isdn');
				while ($entry = $this->_ba->fetch_array($qu)) {
					$ports .=  $entry['port'] . ",";
				}
				$ports=rtrim ($ports, ",");
				
				if (strlen ($ports)) {
					system('/sbin/insmod /usr/local/modules/mISDN_debugtool.ko');
					exec('/usr/local/bin/mISDNdebugtool -d -s ' . $limit_mISDN . ' -f /var/log/ISDNdebug -p ' . $ports);
				}

				
				$qu = $this->_ba->select('SELECT * FROM analog');
				// trace of Analog-Ports
				while ($entry = $this->_ba->fetch_array($qu)) {
					exec('/usr/local/sbin/analog-debugtool > /dev/null &');
					break;
				}

				$qu = $this->_ba->select('SELECT * FROM gsm');
				// trace of GSM-Ports
				while ($entry = $this->_ba->fetch_array($qu)) {
					exec('/usr/local/sbin/gsm-debugtool > /dev/null &');
					
					exec('touch /tmp/ftrace.sms > /dev/null');
					break;
				}

				$qu = $this->_ba->select('SELECT * FROM cas');
				// trace of CAS-Ports
				while ($entry = $this->_ba->fetch_array($qu)) {
					$this->_isgw->caslog(1);
					break;
				}

				// tcpDump-binary
				$tcpDump = '/usr/local/sbin/tcpdump';
				
				$filterPorts = '';
				$filterPortsLan = '';
				$filterPortsLoc = '';
				$filterPortsMsp = '';
				$filterPortsWan = '';
				
				// we record all traffic, except special filters are given
				if ($enable['fulltrace_type'] == 1) {
					
					$xopts=explode(',', $optlimit);
					foreach ($xopts as $xopt) {
						$xvals=explode('=', $xopt);
						if (count ($xvals) != 2) {
							continue;
						}
						//override limits or filters
						if ($xvals[0] == "limit_lan") {
							$limitTcpDumpLan = $xvals[1];
						}
						else if ($xvals[0] ==  "limit_wan") {
							$limitTcpDumpWan = $xvals[1];
						}
						else if ($xvals[0] ==  "limit_msp") {
							$limitTcpDumpMsp = $xvals[1];
						}
						else if ($xvals[0] ==  "limit_lo") {
							$limitTcpDumpLoc = $xvals[1];
						}
						else if ($xvals[0] == "filter_lan") {
							$filterPortsLan = $xvals[1];
						}
						else if ($xvals[0] == "filter_wan") {
							$filterPortsLan = $xvals[1];
						}
						else if ($xvals[0] ==  "filter_msp") {
							$filterPortsMsp = $xvals[1];
						}
						else if ($xvals[0] ==  "filter_lo") {
							$filterPortsLoc = $xvals[1];
						}
					}
				}
				else {
					// otherwise we evaluate what we should record
					$filterPorts = '';
	
					// sip-port
// 					$filterPorts = ' port ' . $this->_sip_udp();
	
	
					//dns
					$filterPorts .= ' port 53';
					//icmp
					$filterPorts .= ((strlen($filterPorts) == 0) ? '' : ' or') . ' icmp';
	

					$filterPortsLan = $filterPorts;
					$filterPortsLoc = $filterPorts;
					$filterPortsMsp = $filterPorts;
					$filterPortsWan = $filterPorts;
					
					
					$port_lan = $this->_sip_udp_lan ();
					$port_wan = $this->_sip_udp_wan ();
	
					
					if (strlen ($port_lan)) {
						$filterPortsLan .= " or port " . $port_lan . " or port " . ($port_lan + 1);
					}
					if (strlen ($port_wan)) {
						$filterPortsWan .= " or port " . $port_wan . " or port " . ($port_wan + 1);
					}
				}
				
				//clean filters of evil characters
				$filterPortsLan = preg_replace('/[^][\/ +=?0-9.a-zA-Z{}():_-]+/', '', $filterPortsLan);
				$filterPortsLoc = preg_replace('/[^][\/ +=?0-9.a-zA-Z{}():_-]+/', '', $filterPortsLoc);
				$filterPortsMsp = preg_replace('/[^][\/ +=?0-9.a-zA-Z{}():_-]+/', '', $filterPortsMsp);
				$filterPortsWan = preg_replace('/[^][\/ +=?0-9.a-zA-Z{}():_-]+/', '', $filterPortsWan);
				
				// define file-names of captures
				$lanCapture = '/var/log/tcpdump.lan.pcap';
				$wanCapture = '/var/log/tcpdump.wan.pcap';
				$locCapture = '/var/log/tcpdump.lo.pcap';
				$mspCapture = '/var/log/tcpdump.msp.pcap';
				
				// run tcpDump
				if ($limitTcpDumpLan > 0) {
					exec("/usr/local/sbin/tcpdump.sh " . $lanCapture . ' ' . $limitTcpDumpLan . ' -i ' . $lanIfName . ' -s0 -U ' . $filterPortsLan . ' > /dev/null &');
				}
				if ($limitTcpDumpWan > 0 && strlen ($wanIfName)) {
					exec("/usr/local/sbin/tcpdump.sh " . $wanCapture . ' ' . $limitTcpDumpWan . ' -i ' . $wanIfName . ' -s0 -U ' . $filterPortsWan . ' > /dev/null &');
				}
				if ($limitTcpDumpLoc > 0) {
					exec("/usr/local/sbin/tcpdump.sh " . $locCapture . ' ' . $limitTcpDumpLoc . ' -i ' . $locIfName . ' -s0 -U ' . $filterPortsLoc . ' > /dev/null &');
				}
				if ($limitTcpDumpMsp > 0) {
					exec("/usr/local/sbin/tcpdump.sh " . $mspCapture . ' ' . $limitTcpDumpMsp . ' -i ' . $mspIfName . ' -s0 -U ' . $filterPortsMsp . ' > /dev/null &');
				}
			}
		}

		// stop a fulltrace
		function stop ($set_date=false) {

			// retrieve data from ISGW
			$isgw_ret = $this->_isgw->isgw_isdnstate();
			$isgw_ret .= $this->_isgw->isgw_actualcalls();
			$isgw_ret .= $this->_isgw->isgw_bchannels();
			$isgw_ret .= $this->_isgw->isgw_callcompact();
			$isgw_ret .= $this->_isgw->isgw_rtpstate();
			$isgw_ret .= $this->_isgw->isgw_listallcallshidden();

			// append ISGW-data to file
			$this->_log_append('isgw.info1', $isgw_ret);
			unset($isgw_ret);

			// write misc stats to log-files
			system('/usr/local/sbin/generate_info.sh /var/log/fulltrace-info.txt');
			system('cat /proc/l1_stats > /var/log/l1_stats');
			system('cat /proc/l2_stats > /var/log/l2_stats');

			// close debug-tools
			system('/bin/sync');
			system('/usr/bin/killall tcpdump.sh');
			system('/usr/bin/killall -9 tcpdump');
			system('/usr/bin/killall -9 mISDNdebugtool');
			system('/usr/bin/killall -9 analog-debugtool');
			system('/usr/bin/killall -9 gsm-debugtool');
			system('/sbin/rmmod mISDN_debugtool');
			system('/bin/sync');

			// mark trace as ended
			$this->_ba->set('trace', 'no');

			// reset ISGW-logging-settings to initial values
			$this->_isgw->logactive($this->_ba->get('logging_debug'));
			$this->_isgw->loglevel($this->_ba->get('loglevel_debug'));
			$this->_isgw->logactive_message($this->_ba->get('logging_message'));
			$this->_isgw->loglevel_message($this->_ba->get('loglevel_message'));
			$this->_isgw->logactive_nmessage(0);
			$this->_isgw->netlog($this->_ba->get('logging_active'));
			$this->_isgw->lld();
			$this->_isgw->Query('nlog0::Fulltrace stopped');

			//stop CAS log
			$this->_isgw->caslog(0);

			// create tar.gz-archive
			system('/bin/rm -f /var/log/DebugFiles.tar.gz');
			system('/bin/rm -f /var/log/info');

			unset($debug_files);

			//create info file
			$info = Helper::getInfo();
			foreach ($info as $key => $val){
				if ($key == 'network') {
					foreach ($val as $netkey => $netval) {
						if ($netkey == 'nameserver') {
							$i = 0;
							foreach ($netval as $dnsVal) {
								file_put_contents('/var/log/info', 'network-nameserver' . $i . ":" . trim($dnsVal) . "\n", FILE_APPEND);
								$i++;
							}
							continue;
						}

						if ($netkey != 'iface') {
			    				file_put_contents('/var/log/info', 'network-' . trim($netkey) . ":" . trim($netval) . "\n", FILE_APPEND);
							continue;
						}

						foreach ($netval as $ifacekey => $ifaceval) {
							foreach ($ifaceval as $ifaceAttrKey => $ifaceAttrVal) {
			    					file_put_contents('/var/log/info', trim($ifacekey) . '-' . trim($ifaceAttrKey) . ":" . trim($ifaceAttrVal) . "\n", FILE_APPEND);
							}
						}
					}
					continue;
				}

				file_put_contents('/var/log/info', trim($key).":".trim($val)."\n",FILE_APPEND);
			}

			// add ISDN-Port-Debug-Files
			if (($isdn_ports = Helper::getIsdnPorts()) != null) {
				foreach($isdn_ports as $isdn_port) {
					if (file_exists('/var/log/ISDNdebug-' . $isdn_port)) {
						$debug_files .= ((strlen($debug_files) == 0) ? ' -C /var/log/' : '') . ' ISDNdebug-' . $isdn_port;
					}
				}
			}
			unset($isdn_ports);

			$tcpdump_files = array(glob('/var/log/*.pcap'), '/var/log/info');
			foreach ($tcpdump_files as $tcpdump_file) {
				if (is_array($tcpdump_file)) {
					foreach ($tcpdump_file as $file) {
						$debug_files .= ((strlen($debug_files) == 0) ? ' -C /var/log/' : '') . ' ' . basename($file);
					}
				}
			}
			unset($tcpdump_files);

			$isgw_files = array(glob('/var/log/isgw.err*'), glob('/var/log/isgw.log*'));
			foreach ($isgw_files as $isgw_file) {
				foreach ($isgw_file as $file) {
					$debug_files .= ((strlen($debug_files) == 0) ? ' -C /var/log/' : '') . ' ' . basename($file);
				}
			}
			unset($isgw_files);

			$misc_files = array('fulltrace-info.txt', 'debug.txt', 'isgw.info1', 'isgw.info2', 'l1_stats', 'l2_stats', 'sofia.log', 'smgw.log', 'smgw.err',
							'analog_debug.log', 'analog_debug.log.1', 'gsm_debug.log', 'gsm_debug.log.1', 'system.log', 'dmesg.log', 'dmesg.log.1',
							'isgw_cas.log','isgw_cas.log.1','cloud.log', 'tdm-bootup.log', 'isgw.nlog.1', 'isgw.nlog.2', 'info', 'log.dmalloc');
			foreach ($misc_files as $misc_file) {
				$debug_files .= ((strlen($debug_files) == 0) ? ' -C /var/log/' : '') . (file_exists('/var/log/' . $misc_file) ? ' ' . $misc_file : '');
			}
			unset($misc_files);

			if (file_exists('/tmp/ftrace.sms') && file_exists('/var/log/sms/')) {
				$debug_files .= " /var/log/sms";
			}

			// add repo_info and configuration-files
			$debug_files .= ((strlen($debug_files) == 0) ? ' -C /var/log/' : '') . (file_exists('/usr/local/repo_info.txt') ? ' /usr/local/repo_info.txt' : '');
			$debug_files .= ' /usr/conf';

			// finally create archive
			$archive_name = '/var/log/DebugFiles.' . (($set_date == true) ? Helper::getDate('"+%c"') . '.' : '') . 'tar.gz';
			system('/bin/tar -czf ' . $archive_name . ' ' . $debug_files);
			system('/bin/sync');
		}
	}

} // END DEFINE _FULLTRACE_CLASS

?>
